/*
 * Copyright (C) 2014 Canonical Ltd
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by Scott Sweeny <scott.sweeny@canonical.com>
 *
 */

#ifndef AGGSCOPELISTENER_H
#define AGGSCOPELISTENER_H

#include "bufferedresultforwarder.h"

class Listener : public BufferedResultForwarder
{
public:
    Listener(unity::scopes::SearchReplyProxy const& upstream, bool buffer,
            std::function<bool(unity::scopes::CategorisedResult&)> const &result_filter);
    virtual void push(unity::scopes::Category::SCPtr const& category) override;
    virtual void push(unity::scopes::CategorisedResult result) override;
    virtual void finished(unity::scopes::CompletionDetails const& details) override;
};

#endif // AGGSCOPELISTENER_H
