/*
 * Copyright (C) 2014 Canonical Ltd
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by Scott Sweeny <scott.sweeny@canonical.com>
 *
 */

#include "listener.h"
#include <QDebug>

using namespace std;
using namespace unity::scopes;

Listener::Listener(SearchReplyProxy const& upstream,
    bool buffer,
    function<bool(CategorisedResult&)> const& result_filter)
    : BufferedResultForwarder(upstream, buffer, result_filter)
{
}

void Listener::push(const Category::SCPtr &category)
{
}

void Listener::push(CategorisedResult result)
{
    BufferedResultForwarder::push(move(result));
}

void Listener::finished(CompletionDetails const& details)
{
    qWarning() << "query complete, status: " << to_string(details.status()) << endl;
    if (details.status() == CompletionDetails::Error) {
        qWarning() << ": " << details.message().c_str();
    }
    BufferedResultForwarder::finished(details);
}

